// Code generated by tablegen. DO NOT EDIT.
package tables

func (t AllTables) Streaks() Streaks { return Streaks(t) }

type Streaks struct{ alias string }

func (t Streaks) TableAlias() string { return t.alias }
func (t Streaks) name() string       { return "Streaks" }
func (t Streaks) TableName() string  { return tableName(t.name(), "", t.alias) }
func (t Streaks) AllColumnNames() []string {
	c := t.Columns()
	return []string{
		c.ID(),
		c.Name(),
		c.CreatedAt(),
		c.CreatedBy(),
		c.DeletedAt(),
		c.DeletedBy(),
		c.UpdatedAt(),
		c.UpdatedBy(),
		c.StreakType(),
		c.Description(),
		c.IDIfNotDeleted(),
		c.PeriodDuration(),
		c.EventsPerPeriod(),
	}
}

func (t Streaks) Columns() StreaksCols { return StreaksCols{tableAlias: t.alias} }

type StreaksCols struct{ tableAlias string }

func (c StreaksCols) ID() string              { return colName(c.tableAlias, "ID") }              // STRING(36)
func (c StreaksCols) Name() string            { return colName(c.tableAlias, "Name") }            // STRING(100)
func (c StreaksCols) CreatedAt() string       { return colName(c.tableAlias, "CreatedAt") }       // TIMESTAMP OPTIONS (allow_commit_timestamp = true)
func (c StreaksCols) CreatedBy() string       { return colName(c.tableAlias, "CreatedBy") }       // STRING(36)
func (c StreaksCols) DeletedAt() string       { return colName(c.tableAlias, "DeletedAt") }       // TIMESTAMP NULL
func (c StreaksCols) DeletedBy() string       { return colName(c.tableAlias, "DeletedBy") }       // STRING(36) NULL
func (c StreaksCols) UpdatedAt() string       { return colName(c.tableAlias, "UpdatedAt") }       // TIMESTAMP NULL OPTIONS (allow_commit_timestamp = true)
func (c StreaksCols) UpdatedBy() string       { return colName(c.tableAlias, "UpdatedBy") }       // STRING(36) NULL
func (c StreaksCols) StreakType() string      { return colName(c.tableAlias, "StreakType") }      // INT64 DEFAULT (1)
func (c StreaksCols) Description() string     { return colName(c.tableAlias, "Description") }     // STRING(1000) DEFAULT ("")
func (c StreaksCols) IDIfNotDeleted() string  { return colName(c.tableAlias, "IDIfNotDeleted") }  // STRING(36) NULL AS (IF(DeletedAt IS NULL, ID, NULL)) STORED
func (c StreaksCols) PeriodDuration() string  { return colName(c.tableAlias, "PeriodDuration") }  // INT64
func (c StreaksCols) EventsPerPeriod() string { return colName(c.tableAlias, "EventsPerPeriod") } // INT64 DEFAULT (1)

func (t Streaks) Indexes() StreaksIndexes { return StreaksIndexes{table: t} }

type StreaksIndexes struct{ table Streaks }

func (i StreaksIndexes) ByIDIfNotDeleted() Index {
	c := i.table.Columns()
	return Index{
		tableAlias: i.table.alias,
		tableName:  i.table.name(),
		indexName:  "Streaks_IDIfNotDeleted",
		columns: []string{
			c.ID(),
			c.Name(),
			c.CreatedAt(),
			c.CreatedBy(),
			c.UpdatedAt(),
			c.UpdatedBy(),
			c.StreakType(),
			c.Description(),
			c.IDIfNotDeleted(),
			c.PeriodDuration(),
			c.EventsPerPeriod(),
		},
	}
}
